package com.lambdazen.bitsy;

import java.util.Collection;
import java.util.List;
import java.util.Set;
import java.util.UUID;

import com.lambdazen.bitsy.store.EdgeBean;
import com.lambdazen.bitsy.store.VertexBean;
import com.tinkerpop.blueprints.Direction;
import com.tinkerpop.blueprints.Element;

public interface IGraphStore {
    public void commit(ICommitChanges changes);

    public VertexBean getVertex(UUID id);

    public EdgeBean getEdge(UUID id);

    public List<EdgeBean> getEdges(UUID vertexId, Direction dir, String[] edgeLabels);
    
    public Collection<VertexBean> getAllVertices();
    
    public Collection<EdgeBean> getAllEdges();
    
    public <T extends Element> void createKeyIndex(String key, Class<T> elementType);
    
    public <T extends Element> void dropKeyIndex(String key, Class<T> elementType);
    
    public <T extends Element> Set<String> getIndexedKeys(Class<T> elementType);
    
    public void shutdown();

    public Collection<VertexBean> lookupVertices(String key, Object value);
    
    public Collection<EdgeBean> lookupEdges(String key, Object value);

    public boolean allowFullGraphScans();
}
